/*------------------------------------------------------------------------
 Module:        ffget.c
 Author:        pldaniels
 Project:       ripmime
 State:         development
 Creation Date: 14/05/2001
 Description:   ffget is a small module which will be used to (we hope) speed up the fgetc()
                routine by line-buffering up first.

------------------------------------------------------------------------*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "ffget.h"

/* DEFINES */
#define _MAX_LINE_LEN 10240

/* GLOBALS */
int ffget_linesize=0;
char *ffget_endpoint=NULL;
char *ffget_currentpoint=NULL;
char *ffget_line=NULL;
FILE *ffget_file=NULL;

int FFGET_setstream( FILE *f )
{
	ffget_file = f;

	if (!ffget_line)
	{
		ffget_line = malloc(sizeof(char) *_MAX_LINE_LEN);
		if (!ffget_line)
		{
			fprintf(stderr,"FFGET - Error: cannot allocate memory for line-buffer.");
			exit(1);
		}
	}

	return 0;
}


char FFGET_fgetc( void )
{
	int c;

	if (ffget_currentpoint == ffget_endpoint) {
		if (fgets(ffget_line, _MAX_LINE_LEN, ffget_file))
		{
			ffget_currentpoint = ffget_line;
			ffget_endpoint = ffget_line +strlen(ffget_line);
		}
		else
		{
			return EOF;
		}
	}


	c = *ffget_currentpoint;
	ffget_currentpoint++;

	return c;
}






